﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;

namespace SilverlightMouseSupport
{
    public static class VisualTreeWalker
    {

        public static FrameworkElement FindName(string name, DependencyObject reference)
        {
            return FindNameInternal(name, reference);
        }

        private static FrameworkElement FindNameInternal(string name, DependencyObject reference)
        {
            foreach (DependencyObject obj in GetChildren(reference))
            {
                FrameworkElement elem = obj as FrameworkElement;
                if (elem != null && elem.Name == name)
                {
                    return elem;
                }

                elem = FindNameInternal(name, obj);

                if (elem != null)
                {
                    return elem;
                }
            }

            return null;
        }

        private static IEnumerable<DependencyObject> GetChildren(DependencyObject reference)
        {
            int childCount = VisualTreeHelper.GetChildrenCount(reference);

            for (int i = 0; i < childCount; i++)
            {
                yield return VisualTreeHelper.GetChild(reference, i);
            }
        }
    }
}
